import GFFFile
import globals

class CExoLocString:

    def __init__(self,gffentry):
        self.locStrings = {}
        self.strref = gffentry[0]
        self.locStrings = dict(gffentry[1])

    def getString(self,langID=0):
        if langID in self.locStrings:
            return self.locStrings[langID]
        elif self.strref != -1:
            if not globals.resourceManager:
                print 'error, no resource manager in CExoLocString'
                return 'Missing ResourceManager'
            else:
                s = globals.resourceManager.getDialogString(self.strref)
                if s != None:
                    return s
                else:
                    return 'Invalid Strref'
        else:
            return ''

    def setString(self,str,langID=0):
        s = None
        if self.strref != -1:
            if not globals.resourceManager:
                print 'error, no resource manager in CExoLocString'
                return 'Missing ResourceManager'
            else:
                s = globals.resourceManager.getDialogString(self.strref)
        if s != str:
            self.locStrings[langID] = str
        
    def toGFFEntry(self):
        return (self.strref,
                zip(self.locStrings.keys(),
                    self.locStrings.values()))

    def __str__(self):
        return self.getString(0)

    def __repr__(self):
        return self.__str__()
