import NeverData

class SituatedObject(NeverData.NeverData):
    propList = {
        'AutoRemoveKey': 'Boolean',
        'CloseLockDC': 'Integer,0-30',
        'Conversation': 'ResRef,DLG',
        'HP': 'Integer,0-1000',
        'Description': 'CExoLocString,4',
        'DisarmDC': 'Integer,0-30',
        'Hardness': 'Integer,0-100',
        'Interruptable': 'Boolean',
        'Lockable': 'Boolean',
        'Locked': 'Boolean',
        'OnClosed': 'ResRef,NSS',
        'OnDamaged': 'ResRef,NSS',
        'OnDeath': 'ResRef,NSS',
        'OnDisarm': 'ResRef,NSS',
        'OnHeartbeat': 'ResRef,NSS',
        'OnLock': 'ResRef,NSS',
        'OnMeleeAttacked': 'ResRef,NSS',
        'OnOpen': 'ResRef,NSS',
        'OnSpellCastAt': 'ResRef,NSS',
        'OnTrapTriggered': 'ResRef,NSS',
        'OnUnlock': 'ResRef,NSS',
        'OnUserDefined': 'ResRef,NSS',
        'OpenLockDC': 'Integer,0-30',
        'Plot': 'Boolean',
        'Ref': 'Integer,0-30',
        'Tag': 'CExoString',
        'TrapDetectable': 'Boolean',
        'TrapDetectDC': 'Integer,0-30',
        'TrapDisarmable': 'Boolean',
        'TrapFlag': 'Boolean',
        'TrapOneShot': 'Boolean',
        'Will': 'Integer,0-30'
        }
            
    def __init__(self,gffEntry):
        NeverData.NeverData.__init__(self)
        self.addPropList('main',self.propList,gffEntry)

    def getName(self):
        return self.gffstructDict['main'].getInterpretedEntry('LocName').getString()
    
    def getX(self):
        return self.gffstructDict['main'].getInterpretedEntry('X')

    def getY(self):
        return self.gffstructDict['main'].getInterpretedEntry('Y')

    def getZ(self):
        return self.gffstructDict['main'].getInterpretedEntry('Z')

    def setX(self,x):
        self.gffstructDict['main'].setInterpretedEntry('X',x)

    def setY(self,y):
        self.gffstructDict['main'].setInterpretedEntry('Y',y)

    def setZ(self,z):
        self.gffstructDict['main'].setInterpretedEntry('Z',z)

    def getBearing(self):
        return self.gffstructDict['main'].getInterpretedEntry('Bearing')

    def getObjectId(self):
        return self.gffstructDict['main'].getInterpretedEntry('ObjectId')

    
    def getPortrait(self,size):
        twoda = self.resourceManager.getResource(ResourceManager.keyFromName('portraits.2da'))
        portraitIndex = self.gffstructDict['main'].getInterpretedEntry('PortraitId')
        baseResRef = twoda.getEntry(portraitIndex,'BaseResRef')
        return self.resourceManager.getResource('po_' + baseResRef + size)


